﻿angular.module("http-interceptor", [])
	.config(['$httpProvider', function ($httpProvider) {
		$httpProvider.interceptors.push([
			'$location', '$injector', '$q', function ($location, $injector, $q) {
				// This interceptor does a couple of things:
				// * http retries

				return {
					'responseError': function (rejection) {
						if (rejection.status !== 404 && rejection.config.retry > 0) {
							// Decrement the number of retries.
							var newRequestConfig = angular.copy(rejection.config);
							newRequestConfig.retry -= 1;

							// console.debug("Retrying. Retries left: " + newRequestConfig.retry + ". " + rejection.config.url);

							// Retry.
							var $http = $injector.get('$http');
							return $http(newRequestConfig);
						}

						return $q.reject(rejection);
					}
				};
			}
		]);
	}
]);